#This source file belongs to e:doc
#Copyright (C) 1999  Thomas M. Schmickl
#This program is free software; you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation; either version 2 of the License.
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
#See the GNU General Public License for more details.
#You should have received a copy of the GNU General Public License
#along with this program; if not, write to the Free Software
#Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

package XXX; #PLACE HERE YOUR REAL CLASSNAME

require class::EmbObj; #It seems to be important that you write "class::EmbObj" with "use" or "require"

@ISA = qw(EmbObj); #It seems to be impotant that you write "EmbObj" in @ISA, but you have to write "Tk::Frame" or "Tk::Derived". ???

Tk::Widget->Construct('XXX'); #PLACE HERE YOUR REAL CLASSNAME

=head1 NAME:

Widget: XXX #PLACE HERE YOUR REAL CLASSNAME

=head1 SYNOPSIS:

use class::XXX; #PLACE HERE YOUR REAL CLASSNAME

=head1 DIRECTORY/FILE:

The file XXX.pm is located in the subdirectory './class'

=head1 DESCRIPTION:

#HERE YOU SHOULD WRITE A BRIEF DESCRIPTION OF YOUR OBJECT

=head1 STATUS:

Coding: 0% done

Documentation: up-to-date

=head1 ATTRIBUTES:

Do not set/read them directly, use the Get/Set methods instead.

All properties derived from the class EmbObj.

# PLACE ADDITIONAL ATTRIBUTES HERE

NOTE: The following attributes are used for the Tk widgets building the GUI and are accessed directly (no get/set methods):

All GUI attributes derived from the class EmbObj.

#PLACE ADDITIONAL GUI STUFF HERE

=head1 METHODS:

=head2 Constructors:

=head3 build_ui

Here your widget could build up all its own widgets and gets initialised

=cut

################
# Fill the GUI #
################
sub build_ui
{
my $self = shift;
my $embed_base = $self->embed_base();

# YOUR WIDGET-CREATION-CODE COMES HERE ....
# NOTE: ALL WIDGETS SHOULD HAVE $embed_base as parent

}

=head2 Destructors:

=head3 do_detstroy

$object->do_detsroy(); 

This "destructor" method is binded to the "<DESTROY>" event and should be performed whenever
the element is destroyed. It should not be called directly.

=cut

###################################################
# Destruktor zum sauberen aufraeumen des Objektes #
###################################################
sub do_destroy
{
my $self =shift;

#YOUR OWN CLEANUP-CODE COMES HERE ....

#THIS SHOULD BE THE LAST CALL HERE
$self->SUPER::do_destroy();
}

=head2 Public data methods (=Get/Set methods):

=cut

##############################
### PUBLIC GET/SET METHODS ###
##############################

#HERE YOU SHOULD PLACE YOUR OWN GET/SET METHODS FOR ALL THE ATTRIBUTES DESCRIBED ABOVE

=head2 Other public methods:

=head3 export_to_backend

my @export_text = $object->export_to_backend(); 

This function exports the content of the object to the current backend.

The function is called in the document-exporting process, whenever an embeded object
is found. 

It returns the text for exporting the object.

=cut

##################################
# Export to the current backend. #
##################################
sub export_to_backend
{
my $self = shift;

#DUMMY-VALUE
my $result = '';

#YOUR EXPORTING CODE COMES HERE

#RETURN THE EXPORT-TEXT
return $result;
}


=head2 Private methods:

=head3 _on_btn_prop_click

$object->_on_btn_prop_click(); 

Overwritten function of EmbObj. This should perform the opening of the properties dialog.

=cut

###########################################
# Callback fuer Klick auf Property-Button #
###########################################
sub _on_btn_prop_click
{
my $self= shift;
$self->SUPER::_on_btn_prop_click();
# here should come the code for opening the ImgObj-Property-Editor
}

=head3 _before_save

$object->_before_save(); 

This function is called before the $self->{'_data'}-subbranch gets saved.

Use this for flatten complicated data structures into {'_data'}.

=cut

################
# _before_save #
################
sub _before_save
{
my $self = shift;
#CALLING THE SUPER-CLASS (DO NOT CHANGE THIS LINE)
$self->SUPER::_before_save();

#YOUR CODE COMES HERE...

}

=head3 _after_save

$object->_after_save(); 

This function is called after the $self->{'_data'}-subbranch got saved.

=cut

###############
# _after_save #
###############
sub _after_save
{
my $self = shift;
#CALLING THE SUPER-CLASS (DO NOT CHANGE THIS LINE)
$self->SUPER::_after_save();

#YOUR CODE COMES HERE...

}

=head3 _before_load

$object->_before_load(); 

This function is called before the $self->{'_data'}-subbranch is loaded from file.

=cut

################
# _before_load #
################
sub _before_load
{
my $self = shift;
#CALLING THE SUPER-CLASS (DO NOT CHANGE THIS LINE)
$self->SUPER::_before_load();

#YOUR CODE COMES HERE...

}

=head3 _after_load

$object->_after_load(); 

This function is called after the $self->{'_data'}-subbranch is loaded from file.

Use this function to build up complicated data structures from the flat {'_data'}-subbranch

=cut

###############
# _after_load #
###############
sub _after_load
{
my $self = shift;
#CALLING THE SUPER-CLASS (DO NOT CHANGE THIS LINE)
$self->SUPER::_after_load();

#YOUR CODE COMES HERE...

}

=head3 _before_expand

$object->_before_expand(); 

This function is called before the object gets expanded.

=cut

##################
# _before_expand #
##################
sub _before_expand
{
my $self = shift;
#CALLING THE SUPER-CLASS (DO NOT CHANGE THIS LINE)
$self->SUPER::_before_expand();

#YOUR CODE COMES HERE...

}

=head3 _after_expand

$object->_after_expand(); 

This function is called after the object gets expanded.

=cut

#################
# _after_expand #
#################
sub _after_expand
{
my $self = shift;
#CALLING THE SUPER-CLASS (DO NOT CHANGE THIS LINE)
$self->SUPER::_after_expand();

#YOUR CODE COMES HERE...

}

=head3 _before_collapse

$object->_before_collapse(); 

This function is called before the object gets collapsed.

=cut

####################
# _before_collapse #
####################
sub _before_collapse
{
my $self = shift;
#CALLING THE SUPER-CLASS (DO NOT CHANGE THIS LINE)
$self->SUPER::_before_collapse();

#YOUR CODE COMES HERE...

}

=head3 _after_collapse

$object->_after_collapse(); 

This function is called after the object gets collapsed.

=cut

###################
# _after_collapse #
###################
sub _after_collapse
{
my $self = shift;
#CALLING THE SUPER-CLASS (DO NOT CHANGE THIS LINE)
$self->SUPER::_after_collapse();

#YOUR CODE COMES HERE...

}

=head3 _after_backend_changed

$object->_after_backend_changed(); 

This function is called after the current backend changed

=cut

##########################
# _after_backend_changed #
##########################
sub _after_backend_changed
{
my $self = shift;
#CALLING THE SUPER-CLASS (DO NOT CHANGE THIS LINE)
$self->SUPER::_after_backend_changed();

#YOUR CODE COMES HERE...

}

1; #So muss ein Package enden


=head1 KNOWN BUGS:

=head1 STILL MISSING:

=cut
