#!/usr/bin/perl 

#I have not used the -w switch in the line above, because the code of the BEGIN-block causes a lot of warnings, I turn the -w functionality on manually after the BEGIN-block is executed.

#This source file belongs to e:doc
#Copyright (C) 1999  Thomas M. Schmickl
#This program is free software; you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation; either version 2 of the License.
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
#See the GNU General Public License for more details.
#You should have received a copy of the GNU General Public License
#along with this program; if not, write to the Free Software
#Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

BEGIN
# experimental: splash screen 
# Code posted from Slaven Rezic in comp.lang.perl.tk (11. Dez. 1999)
# A little bit modified by Thomas Schmickl to run also on Windows NT4.0,
# but a little bit slower in coming up of the splashscreen.
# This code might be incompatibe with later versions of Perl/Tk, but you can easily remove it,
# the only things that happens then is that you have to live without a splashscreen.
# Its tested with Perl/Tk version 800.011 and ActiveState Perl version 5.005_03 on Windows NT 4.0 SP3
# and the versions of Perl/Tk and Perl that are contained in Debian GNU Linux 2.1 (slink). 
	{ 
	#error_flag
	$main::killme = 0;
	$main::min_tk_version = 800.022;
	#Dummy values (but important to be here)
	$main::project_path = '.';
	$main::project_path_long = undef;
	$main::project_path_long = $main::project_path.'/';
	#version info
	$prg_version = '0.2.0';
	$fs_version = '0.0.3';
	
	#extracting the file path of the script
	my $script_filename = $0;
	$main::edoc_path = $script_filename;

	if ($^O =~ /WIN32/i)
		{
		print "Operating System: Win32 \n";
		$main::os_type = 'win32';
		$main::path_separator = "/"; #In former days I had "\" herebwith Win32 systems, but that mixed up "\" and "/" later throughout the program
		}
	else
		{
		print "Operating System: Unix-like \n";
		$main::os_type = 'unix';
		$main::path_separator = "/";
		}

	if ($main::edoc_path =~ /^(.*)[\/\\]/) #UNIX-style pathes seperated by '/'
		{
		$main::edoc_path = $1;
		$main::edoc_path =~ s/\\/\//g  if $main::os_type eq 'win32';
		}
	else #No path before the filename
		{
		$main::edoc_path = '.';
		}

	#use URI::file;
	#$uri = URI::file->new($main::edoc_path."/edoc.pl");
	#print "URI:".$uri->abs(URI::file->cwd)->file."\n"; #debug1

	#NOW GET TH ABSOLUTE E:DOC PATH FOR LATER REUSE
	use FindBin qw($RealBin);
	$main::edoc_path = $RealBin;
	print "e:doc script is in path: \"$main::edoc_path\"\n"; #debug

	#Test if Perl/Tk is installed
	eval
		{
		require Tk; #For test
		};
	if ($@)
		{
		$main::killme = 1;
		die ("\nCRITICLAL ERROR: \nYou do not have Perl/Tk installed on your machine !\nI need Perl/Tk-Version $main::min_tk_version or higher !\nPlease update the 'Perl/Tk'-package !\nYou can find a file called './docs/faq.htm'\nthat explains you how to find the current version!\n\n\n");
		}

	##### SPLASHSCREEN-CODE STARTS HERE ######
	eval 
		{
		# change this for your needs:
		my $image_file = $main::edoc_path."/edoc.gif";
		my $image_width = 300;
		my $image_height = 160;
		my $title = "e:doc";

		package Tk;
		require DynaLoader;
		eval q{ require Tk::Event };
		@ISA = qw(DynaLoader);
		bootstrap Tk;
		sub TranslateFileName { $_[0] };
		sub SplitString { split /\s+/, $_[0] }; # rough approximation

		package Tk::Photo;
		@ISA = qw(DynaLoader);
		bootstrap Tk::Photo;
		
		package main;
		sub _Destroyed { };
		$main::splash_screen = Tk::MainWindow::Create(".", $title);
		bless $main::splash_screen, Tk::MainWindow;
		Tk::image($main::splash_screen, 'create', 'photo', 'splashphoto', -file => $image_file);
		my $sw = Tk::winfo($main::splash_screen, 'screenwidth');
		my $sh = Tk::winfo($main::splash_screen, 'screenheight');
		Tk::wm($main::splash_screen, "geometry", "+" . int($sw/2 - $image_width/2) . "+" . int($sh/2 - $image_height/2));
		
		#I changed something from here ...
		require Tk; #To have access to the normal methods to work with Tk, because I do not know how to work "magic" like Slaven
		$main::border = $main::splash_screen->Frame(-borderwidth=>3, relief=>'raised')->pack(-expand=> 1, -fill=>'both');
		$main::splash_screen->maxsize($image_height, $image_width);
		my $picture = $main::border->Label(-image => 'splashphoto')->pack(-fill => 'x', -expand => 0, -side=>'top'); #Produce&pack the label that holds the image
		my $text="This is Version $main::prg_version of e:doc, the highconfigurable,\n multibackend, OS-independend, opensource document processor.\n";
		$text .= "(c) by Thomas Schmickl, 1999\nLicensed under Version 2.0 of the GNU General Public License (GPL)\n";
		my $separator = $main::border->Frame(-height=>'14',-borderwidth=>3)->pack(-expand=>1, -fill=>'x', -side=>'top');
		$main::splash_message = 'Starting e:doc ...';
		$main::aboutbox_progress = undef; #prevent warnings
		$main::aboutbox_progress = $separator->Label(-relief=>'sunken', -textvariable=>\$main::splash_message)->pack(-fill=>'both',-expand=>1);
		my $message = $main::border->Label(-text=>$text, -justify=>'center', -borderwidth=>10)->pack(-side=>'top'); #Produce&pack the Text
		$main::splash_screen->overrideredirect(1); #removing the window decorations
		
		#Check the Perl-Tk version
		my $version = $Tk::VERSION;
		print "Perl Version = $] \n";
		print "Perl/Tk Version = $version \n";
		if ($version < $main::min_tk_version) 
			{
			$main::killme = 1;
			die("\nCRITICLAL ERROR: \nI need Perl/Tk-Version $main::min_tk_version or higher !\nPlease update the 'Perl/Tk'-package !\nYou can find a file called './docs/faq.htm'\nthat explains you how to find the current version!\n\n\n");
			}
		#...to here
     
		Tk::update($main::splash_screen);
		}; # end of eval-block
	warn $@ if $@;
	##### SPLASHSCREEN-CODE ENDS HERE ######
	}

$^W = 1; #switch on warnings again

#Check for errors in the begin-block
if ($main::killme == 1)
	{
	exit(0);
	}

use strict;
use diagnostics;

$main::splash_message = 'Loading Perl standard modules';
$main::splash_screen->update();

use lib $main::edoc_path;
use lib $main::edoc_path.$main::path_separator."class";
use lib $main::edoc_path.$main::path_separator."widgets";

require IO::File;
require Time::Local;
require Time::localtime;

$main::splash_message = 'Loading Tk toolkit (base)';
$main::splash_screen->update();
require Tk; #If somebody has removed the splashscreen-code (BEGIN-block)

$main::splash_message = 'Loading Tk toolkit (extra widgets)';
$main::splash_screen->update();
require Tk::Balloon;
require Tk::NoteBook;
require Tk::LabFrame;
require Tk::Tree;
require Tk::Dialog;
require Tk::Pane;
require Tk::Text;
require Tk::BrowseEntry;
require Tk::Adjuster;

$^W = 0; #switch off warnings
require lib::TkPatch; #Overrides functions in the Perl/Tk distribution (Has to be loaded AFTER all changed Perl/Tk files are included by 'use' or 'require')
$^W = 1; #switch on warnings again

$main::splash_message = 'Loading e:doc classes';
$main::splash_screen->update();
require class::NumLabel; #AbsatzNummernLabel-Objekt
require class::NumList; #AbsatzNummernLabel-Listen-Objekt
require class::TagMan; #Tagmanager-Objekt
require class::ComObj; #Command-Objekt
require class::TagDoc; #TagDoc object
require class::EmbObj; #Embeded-Objekt
require class::ArgEdit; #Widget, welches Argumente zu Absatz-, Umgebungs- und Zeichenformaten und Kommandos editieren laesst
require class::TagForm; #Fenster, welches Argumente zu Absatz-, Umgebungs- und Zeichenformate editieren laesst
require class::BaseForm; #Base class for the forms
require class::PrjForm; #Class for the project form
require class::DocForm; #Class for the document form
require class::TemplateChooser; #Class for the Template choosing dialog

require class::ui::uiBaseForm; #The general GUI elements
require class::ui::uiDocForm; #The GUI for the document form
require class::ui::uiPrjForm; #The GUI for the project form

$main::splash_message = 'Loading e:doc library';
$main::splash_screen->update();
require lib::Config; #Contains all functions for processing the configuration files
require lib::Filesys; #Contains all functions managing the e:doc fileformat
require lib::Backend; #Contains all functions for translating the document into the backends format
require lib::Language; #Contains all functions for the style/output-definition-language
require lib::InOut; #Contains all functions for reading/writing files
require lib::Macro; #Contains all functions for executing macros
require lib::Parts; #Contains all functions for managing 'parts'
require lib::Utils; #Contains all functions that didn't fit somwhere else

=head1 NAME:

edoc.pl

=head1 SYNOPSIS:

perl edoc.pl

=head1 DIRECTORY/FILE:

The file edoc.pl is located in the e:doc-rootdirectory

=head1 DESCRIPTION:

This script starts the program and displays project window
(covered by the object 'PrjForm')from which you can start multiple
document windows with different files.

First, it creates the 2 anonymous hashes $main::config and $main::internal .
Then it calles the function _load_config to fill these hashes
with the data of the files 'edoc.cfg' and 'edoc.int'.
Afterwards it creates a new object of the class 'PrjForm' and
enters the 'MainLoop' of all Perl/Tk programs.

=head1 GLOBAL VARIABLES:

(+) $main:config      : A reference to a (big) hash that holds all configuration settings from the file 'edoc.cfg' and all macros form 'edoc.mac' and all other '*.mac'-files

(+) $main:internal      : A reference to a (very big) hash that holds all style-definitions from the file 'edoc.int'

(+) $main:project      : A reference to a (very big) hash that holds all project definitions from the file 'edoc.prj'

(+) $main::global_parts  : A reference to an hash of arrays holding all 'global parts' in clipboard format

(+) @main::clipboard  : An global array holding the clipboards content



=head1 FUNCTIONS:

=cut

###################
### Main script ###
###################

#Build up the e:doc internal clipboard
@main::clipboard = ();
@main::clipboard = (); #Mentioned here twice to avoid warnings of perl

#Reference to hash with global configuration data
my $config = {};
$main::config = undef; #Prevent perl-warnings
$main::config = $config; # the anonymous $config-hash is stored as a global $main::config hash to let all packages have easy access

#Reference to hash with project definition data
my $project = {};
$main::project = undef; #Prevent perl-warnings
$main::project = $project; # the anonymous $config-hash is stored as a global $main::config hash to let all packages have easy access


#Reference to the hash that holds the internal style definitions
my $internal = {};
$main::internal = undef; #Prevent perl-warnings
$main::internal = $internal; # the anonymous $internal-hash is stored as a global $main::internal hash to let all packages have easy access

#Creating the hash for the 'global_parts'
$main::global_parts_changed = undef;
$main::global_parts_changed = 0;
$main::global_parts = undef; 
$main::global_parts = {}; 

#Read the configuration files (edoc.cfg, edoc.int, edoc.mac ...) into the hashes
_load_configuration_files( ); 

#Create global reference to the displayed combo-pixmap (FIXME: reference is set later, SHOULD BE MOVED HERE)
$main::combo_pixmap = undef;
$main::combo_pixmap = undef;

#Create a global array that holds all opened Forms
@main::forms = undef;
@main::forms = ();

#Create a global array that holds all opened Document Forms
@main::docforms = undef;
@main::docforms = ();

#Create a global variable for holding the reference to the current docform (if any)
$main::docform = undef;
$main::docform = undef;

#Create a global varaibale for holding a reference to the Project Form
$main::prjform = undef;

#Process the templates directory
my $templates_dir = $config->{'GENERAL'}->{'templates_dir'};
$templates_dir =~ s/%EDOC_PATH%/$main::edoc_path/;
if (not -d $templates_dir)
	{
	die "\nCRITICAL ERROR: The templates directory does not exist. Change that in the file '/config/edoc.cfg' !\n\n";
	}
#Store the processed value for later reuse (IMPORTANT, maybe we should perform this at tartup in edoc.pl)
$config->{'GENERAL'}->{'templates_dir'} = $templates_dir;
print "Templates directory: '$templates_dir'\n";

$main::splash_message = 'Opening project...';
$main::splash_screen->update();

#Create the PROJECT FORM (is the applications MainWindow)
$main::prjform = PrjForm->new($config);

#display the form before entering the MainLoop
$main::prjform->app_window()->idletasks();

#Checking fot command line arguments comes here ....
if (@ARGV)
	{
	foreach my $arg (@ARGV)
		{
#		if (($arg =~ /\.(edc|EDOC)$/i ) and (-f $arg) )
#			{
#			my $new_docform = $prj_form->open_docform_file($arg);
#			$prj_form->app_window()->idletasks();
#			$new_docform->top()->idletasks();
#			}
		if (($arg =~ /\.edp$/i) and (-f $arg))
			{
			$main::prjform->project_open($arg);
			$main::prjform->app_window()->idletasks();
			last;
			}
		}
	}
else
	{
	$main::prjform->project_open($main::edoc_path."/samples/tutorial.edp");
	$main::prjform->app_window()->idletasks();
	}


#If nobody had removed the splashscreen-code, hide it
$main::splash_screen->withdraw() if defined $main::splash_screen;

$main::prjform->app_window()->deiconify();

$main::prjform->app_window()->raise();

$main::prjform->content()->focus();

Tk::MainLoop();  # I have to call Tk::Mainloop() instead of MainLoop(). Maybe because I used "require Tk;" above instead of "use Tk;"


=head2 _load_configuration_files()

my $ok = _load_configuration_files(); 

Read the contents of 'edoc.cfg', 'edoc.int', 'edoc.mac', '*.mac' and 'edoc.pts' into the two anonymous hashes referenced by $main::internal, $main::config and $main::global_parts.

=cut

########################################################################################################################################
### This loads the information of the configuration files into the configuration hashes referenced by $main::internal, $main::config ###
########################################################################################################################################
sub _load_configuration_files
{

#READ 'edoc.cfg'
$main::splash_message = 'Loading configuration from "edoc.cfg".';
$main::splash_screen->update();
Config::load_config();

#READ 'edoc.int'
$main::splash_message = 'Loading internal document definition from "edoc.int".';
$main::splash_screen->update();
Config::load_internal();


#READ 'edoc.prj'
$main::splash_message = 'Loading configuration from "edoc.prj".';
$main::splash_screen->update();
Config::load_project();


$main::splash_message = 'Loading macros definition from "edoc.mac".';
$main::splash_screen->update();
Config::load_macros();

#Read 'edoc.pts'
$main::splash_message = 'Loading global parts from "edoc.pts".';
$main::splash_screen->update();
Parts::load_global_parts();

# VERSION #
$main::internal->{'fs_version'} = $main::fs_version; #Aktuelle Version des Dateisystems
$main::internal->{'prg_version'} = $main::prg_version; #Aktuelle Version des Programmes
# VERSION #

return 1; #return 1 if everything went o.k., no error check is done here yet
}


=head1 KNOWN BUGS:

=head1 STILL MISSING:

=cut
