# This script copies all files from the win32-branch to the unix-branch
# and removes the carriage returns

use strict;

my $win32_base = './redist';
my $unix_base = '../unix/redist';
my @directories = ('','class','class/ui','lib','docs','graphics','widgets', 'config', 'samples', 'templates');
my @copy_ext = ('pts', 'prj', 'xpm', 'xbm', 'gif', 'bmp', 'ico', 'pbm', 'jpg', 'pm', 'pl', 'txt', 'edc', 'edp', 'edl', 'bat', 'shell', 'int', 'out', 'mac', 'cfg', 'linux', 'win32', 'htm', 'html', 'eps');
my @text_ext = ('pts', 'prj', 'pm', 'pl', 'txt', 'edc', 'edl', 'edp', 'bat', 'shell', 'int', 'out', 'mac', 'cfg', 'linux', 'win32', 'htm', 'html');

foreach my $source_dir (@directories)
	{
   opendir (DIR, $win32_base."/".$source_dir);
	my @files = readdir(DIR);
	foreach my $file (@files)
		{
		if (test_copy_extension($file) == 1)
			{
			if (test_text_extension($file) == 1)
				{
				my $source = $win32_base."/".$source_dir."/".$file;
				my $target = $unix_base."/".$source_dir."/".$file;
				print "Copy (ASCII) $source -> $target \n";
				copy_file_text($source, $target)
				}
			else
				{
				my $source = $win32_base."/".$source_dir."/".$file;
				my $target = $unix_base."/".$source_dir."/".$file;
				print "Copy (binary) $source -> $target \n";
				copy_file_binary($source, $target)
				}
			}
		}
	}


sub test_copy_extension
{
my $file = shift;
my $extension = extract_extension($file);
my $flag = 0;
foreach my $item (@copy_ext)
	{
	$flag = 1 if $extension eq $item;
	}
return $flag;
}

sub test_text_extension
{
my $file = shift;
my $extension = extract_extension($file);
my $flag = 0;
foreach my $item (@text_ext)
	{
	$flag = 1 if $extension eq $item;
	}
return $flag;
}

sub extract_extension
{
my $file = shift;
my $result = '';
if ($file =~ /(.*)[\\\/](.*)$/ ) {$file = lc($2)};
if ($file =~ /(.*)\.(.*)/ ) {$result = lc($2)};
return $result;
}

sub copy_file_binary
{
my $from = shift;
my $to = shift;
use File::Copy;
copy($from, $to);
}

sub copy_file_text
{
my $from = shift;
my $to = shift;

open (INFILEHANDLE, "<$from") or die "cannot open input file $from !\n";
open (OUTFILEHANDLE, ">$to") or die "cannot open output file $to !\n";
binmode OUTFILEHANDLE;
while (defined (my $line = <INFILEHANDLE>))
	{
	$line =~ s/\r//g ;
	print OUTFILEHANDLE $line;
	}

close INFILEHANDLE;
close OUTFILEHANDLE;

}
