use Tk;
use XGrid;
use strict;

my $mw = MainWindow->new();
$mw->configure(-title=>'XGrid Test');
$mw->geometry('600x450+10+10');
my $grid = $mw->XGrid(-initialcols=>5, -initialrows=>5);

my $options = {'-background'=>'orange', '-foreground'=>'blue', '-font'=>'-adobe-times-bold-r-normal-*-18-*-*-*-p-*-*-*'};
$grid->define_style('HEADING', $options);

my $button_frame = $mw->Frame(-height=>'20', -borderwidth=>'3', -relief=>'ridge')->pack(-side=>'bottom', -fill=>'x', -pady=>10);

my $btn_test1 = $button_frame->Button(-text=>'Add 5 rows', -command=>[\&test1] )->pack(-expand=>1, -fill=>'x');
my $btn_test2 = $button_frame->Button(-text=>'Add 5 columns', -command=>[\&test2] )->pack(-expand=>1, -fill=>'x');
my $btn_test3 = $button_frame->Button(-text=>'Write content into first row', -command=>[\&test3] )->pack(-expand=>1, -fill=>'x');
my $btn_test4 = $button_frame->Button(-text=>"Change display style to 'HEADING' in the first row", -command=>[\&test4] )->pack(-expand=>1, -fill=>'x');
my $btn_test5 = $button_frame->Button(-text=>"Fill the rest of the table, create a style 'DATA' and assign it to the cells", -command=>[\&test5] )->pack(-expand=>1, -fill=>'x');
my $btn_test6 = $button_frame->Button(-text=>"Delete style 'DATA' from the style-definition list again", -command=>[\&test6] )->pack(-expand=>1, -fill=>'x');

$grid->pack(-expand=>1, -fill=>'both');

MainLoop();

# Add 5 rows #
sub test1
{
for (my $row = 1; $row <= 5; $row++)
	{
	$grid->add_row();
	}
}

# Add 5 columns #
sub test2
{
for (my $col = 1; $col <= 5; $col++)
	{
	$grid->add_col();
	}
}

# Write content into first row #
sub test3
{
for (my $col = 1; $col <= $grid->cols(); $col++)
	{
	$grid->put($col, 1, "This is the heading of\ncolumn number $col");
	}
}

# Change style in first row #
sub test4
{
for (my $col = 1; $col <= $grid->cols(); $col++)
	{
	$grid->set_cell_style($col, 1, 'HEADING');
	}
}

# Fill the rest of the table, create a style 'DATA' and assign it to the cells #
sub test5
{
#Create a new style
$options = {'-background'=>'beige', '-foreground'=>'red', '-font'=>'-adobe-times-*-*-*-*-18-*-*-*-p-*-*-*'};
$grid->define_style('DATA', $options);

for (my $row = 2; $row <= $grid->rows(); $row++)
	{
	for (my $col = 1; $col <= $grid->cols(); $col++)
		{
		$grid->put($col, $row, "Content of \ncell $col/$row");
		$grid->set_cell_style($col, $row, "DATA");
		}
	}
}

# Delete style 'DATA' from the style-definition list again #
sub test6
{
$grid->delete_style('DATA');
}

